; ------------------------------------------------
; 
;  AXE (GAME)
;  BY la1n.ch
;
; ------------------------------------------------
;  the coder of this game will
;  be directly teleported to 
;  coders hell
;  "sorry - the code is "*ç+"ç"*ç"+ç*+"
;
;  code & design: t00cg
;  email: rene.bauer@zhdk.ch
;
; coming from 68000 - with the 6502 
; everything is handmade and no vram
; is even less than on atari st
;
; gamemechanics: hacknslash
;
; this is a simple hack and slash
; with the original 2 hardware sprites
;
; you can beat the others. dont let 
; them stab you! of course you can 
; use the borders to flew the enemies
;
; version: 0.7b
; waves (levels): more than 3 (find out :-)
; 
; todos: more levels, monsters, balancing, 
; level display, sound design and and and
;
    processor 6502
    include vcs.h
    org $F000

; game stati
GameStatus  = $88; ; 0 intro 1 game 2 game over
GameStatusSub  = $89; 0 playing 1 wait for jump in ... 

; animation status
AnimationCounter = $98
AnimationCounterIndex = $99

; player
PlayerAmount    = $9B
PlayerDirection = $9C ; Player direction 0: neutral 1: left 2: right

PlayerStatus = $95; ; 0 doing nothing 1 hacking 2 defeat 3 death 4 shield
XPosPlayer0 = $80;
YPosPlayer0 = $81;
PlayerBuffer0 = $82 

PlayerWon      = $AA
PlayerWonCounter = $AC
PlayerDeadCounter  = $AB

NewFireButton  = $A8

PlayerFireCountDown = $9A ; just used for animation count down .. 

; enemies
EnemyWave  = $92;
EnemyAttackBehavior = $8A ; -x---x 
EnemyMoveBehavior = $A0 ; -x---x 
EnemyStatus = $96 ; 0 running 1 hacking 2 defeat???? 3 death 4 shield
EnemyInterval = $94;  
EnemyAmount  = $93;

EnemyWavePosition = $9E
EnemyWavePositionCounter = $9D

EnemyCounter = $86
EnemyCounterIndex = $87

EnemyBehaviour = $8B
EnemyBehaviourRotateIndex = $8E ; 0 - 7 > 0
EnemyBehaviourCounter = $8C
EnemyBehaviourIndex = $8D
EnemyDirection = $8F

XPosPlayer1 = $83;
YPosPlayer1 = $84;
PlayerBuffer1 = $85 ;setup an extra variable


; background
BackgroundColor = $90
BackgroundColorHit = $12

; Audio Channel 0
AudioChannel0Counter = $A4
AudioChannel0Index = $A5
AudioChannel0Val    = $A6

; Audio Channel 1
SoundClk    = $A2
PlaySound   = $A3 ; 0: nothing 1: effect 0 2: effect 1 etc ...

FlackerToggle = $A7

LastCounter     = $A9



; -------------------------------------------------
; INIT
; -------------------------------------------------


;generic start up stuff...

Start
    SEI 
    CLD     
    LDX #$FF    
    TXS 
    LDA #0    
; Clear Memory     
ClearMem 
    STA 0,X     
    DEX     
    BNE ClearMem  

; GAMES
    ; lda #0
    ; sta GameStatus
    lda #$40
    sta BackgroundColor
    lda #$50
    sta BackgroundColorHit
    ; start game
    jsr InitGameBackoffice
    ; jsr StartGame

; Ball
    LDA #2
    STA ENABL
    LDA #$1E
    STA HMBL 

; -------------------------------------------------
; MAINLOOP
; -------------------------------------------------

;VSYNC time
MainLoop
    LDA #2
    STA VSYNC   
    STA WSYNC   
    STA WSYNC   
    STA WSYNC   
    LDA #43 
    STA TIM64T  
    LDA #0
    STA VSYNC   

    ; -------------------------------------------------
    ; INTRO
    ; -------------------------------------------------

    ; -------------------------------------------------
    ; SOUND / AUDIO
    ; -------------------------------------------------
    jsr DoAudio


    ; -------------------------------------------------
    ; INGAME
    ; -------------------------------------------------
    lda GameStatus
    cmp #0
    bne  IngameEndE
    jmp IngameEnd
IngameEndE

    ; wait before go on
    ; attention: not scanline area!!!
    lda PlayerStatus
    cmp #3
    bne NotLastCounterWaitDone
    ; wait for fire
    ; cpy #100
    ; bne NotLastCounterWaitDone
    lda LastCounter
    cmp #40
    bcc NotLastCounterWait
    ; version 1.0 
    ; jsr StartGame
    lda #%10000000              ; A = $80
    bit INPT4
    bne NoFireButtonX
    ; lda PlayerWonCounter
    ; cmp #20
    ; bcc NoFireButtonX
    jsr StartGame
NoFireButtonX
    jmp NotLastCounterWaitDone
NotLastCounterWait
    inc LastCounter
NotLastCounterWaitDone 

    ; -------------------------------------------------
    ; HEADER (LOGO)
    ; -------------------------------------------------

    ; -------------------------------------------------
    ; WAVE / LEVELS
    ; ------------------------------------------------- 

    ; -------------------------------------------------
    ; ENEMY BEHAVIOUR
    ; -------------------------------------------------
    jsr DoIngameEnemeyBehaviour  

    ; -------------------------------------------------
    ; NUMBER SIZE
    ; -------------------------------------------------
    jsr DoIngameSize


    ; -------------------------------------------------
    ; PLAYERMOVEMENTS
    ; -------------------------------------------------
    ; JOYSTICK CONTROL
    jsr DoIngamePlayerMovement


    ; -------------------------------------------------
    ; / PLAYER INPUT
    ; -------------------------------------------------

    ; -------------------------------------------------
    ; PLAYER FIGHT
    ; -------------------------------------------------
    lda PlayerStatus
    cmp #1
    bne NOPLAYERSTATUS1
    lda PlayerFireCountDown
    cmp #1
    bcc FIGHTOVER
    ; lda #121
    ; sta COLUBK    
    dec PlayerFireCountDown
    lda PlayerFireCountDown
    cmp #0
    bne FIGHTOVER
    ; lda #122
    sty COLUBK    
    lda #0
    sta PlayerStatus
FIGHTOVER
NOPLAYERSTATUS1

    ; DEAD GO TO MENU
    lda NewFireButton    
    cmp NOTDEAD

NOTDEAD

    ; SKIP?
    ; CPY #80
    ; BNE NoCollision

    ; -------------------------------------------------
    ; COLLISIONS
    ; -------------------------------------------------
    ; see if player and missile collide, and change the background color if so
    lda EnemyStatus
    cmp #3 ; // enenmystatus!=3
    beq ENEMYNOTACTIVE
    cmp #4 ; // enenmystatus!=4
    beq ENEMYNOTACTIVE
    LDA #%10000000     
    BIT CXPPMM ; player1 player2      
    BEQ NoCollision ;skip if not hitting...
    ; new GameStatus
    ; case a: kill the enemies
    lda PlayerStatus
    ; player is passive
    cmp #0
    bne PlayerStatus_0
    ; kill on every contact?
    lda EnemyStatus
    cmp #1
    bne PlayerStatus_0
    jsr PlayerDeath
    jmp ENEMYNOTACTIVE
PlayerStatus_0
    ; player is attacking
    lda PlayerStatus
    cmp #1 ; playerstatus==1
    bne PlayerStatus_1
    lda EnemyStatus
    cmp #0 ; enemystatus==0
    bne PlayerStatus_1Death
    ; attacking - killing the deaths.
    jsr EnemyDeath
    jmp ENEMYNOTACTIVE
PlayerStatus_1Death ; enemystatus!=0   
    ; player dies .. 
    ; todo: subroutine die
    jsr PlayerDeath
    jmp ENEMYNOTACTIVE
PlayerStatus_1
    ; player is defeating
;    lda PlayerStatus
;    cmp #2
;    bne PlayerStatus_2
;    jmp ENEMYNOTACTIVE
PlayerStatus_2
NoCollision

ENEMYNOTACTIVE
    STA CXCLR   ;reset the collision detection for next time

 

    ; -------------------------------------------------
    ; Animation
    ; -------------------------------------------------
    inc AnimationCounter
    lda AnimationCounter
    cmp #10
    bcc AnimationIndex
    lda #0
    sta AnimationCounter
    inc AnimationCounterIndex
    lda AnimationCounterIndex
    cmp #2
    bne AnimationIndex
    lda #0
    sta AnimationCounterIndex
    ; sta COLUBK
AnimationIndex    

    ; do ingame enemies
    jsr DoIngameEnemies

 
    ; won or died wait .. ...
    lda PlayerWonCounter
    cmp #10
    bcs CountUp
    cmp #240
    bcc CountUp
    inc PlayerWonCounter
CountUp

IngameEnd



WaitForVblankEnd
    LDA INTIM   
    BNE WaitForVblankEnd    
    LDY #191    
    STA WSYNC   
    STA HMOVE   
    STA VBLANK      

;main scanline loop...

    ; -------------------------------------------------
    ; INTRO
    ; -------------------------------------------------
    lda GameStatus
    cmp #1
    beq INGAME
INTRO
    jsr DoIntro
    JMP ENDOFSCANLOOP

    ; -------------------------------------------------
    ; INGAME
    ; -------------------------------------------------
INGAME

  

    ; -------------------------------------------------
    ; SCANLOOP
    ; -------------------------------------------------
    
    lda #0
    sta COLUBK

ScanLoop 

    STA WSYNC   

    ; BACKGROUND
    cpy #100
    bne NOBACKGROUND
    ; background
    lda PlayerStatus
    cmp #3 ; dead
    bne NORMALBACKGROUND
    lda PlayerWon
    cmp #1
    beq HERX    
    lda #$f2
    sta COLUBK
    JMP NOBACKGROUNDE
HERX
    lda #$c2
    sta COLUBK
    JMP NOBACKGROUNDE
NORMALBACKGROUND
    lda BackgroundColor
    sta COLUBK
NOBACKGROUND
    cpy #60
    bne NOBACKGROUNDE
    lda #0
    sta COLUBK
NOBACKGROUNDE

    ; -------------------------------------------------
    ; PLAYERS
    ; -------------------------------------------------
     CPY YPosPlayer0
     BNE SkipActivatePlayerX
     LDA #8
     STA XPosPlayer0
     STA XPosPlayer1
SkipActivatePlayerX

    ; -------------------
    ; Player Render
    ; -------------------
    jsr DoIngamePlayerRenderer

    ; -------------------
    ; ENEMY Render
    ; -------------------
    ; JMP FinishPlayer1
    STA PlayerBuffer1   ;set buffer, not GRP0
    LDX XPosPlayer1   ;check the visible player line...
    BEQ FinishPlayer1    ;skip the drawing if its zero...
    lda EnemyStatus
    cmp #3 ; // player 3 > death 
    beq FinishPlayer1Dead 
IsPlayerOn1  
    LDA #30  
    sta COLUP1
    LDA AnimationCounterIndex
    cmp #1
    bne DisplayAnimationEnemy
    LDA VISENEMY00-1,X
    STA PlayerBuffer1
    lda EnemyStatus
    CMP #1
    BNE DisplayAnimationEnemyEnd  
    LDA VISENEMYATTACK00-1,X  
    STA PlayerBuffer1 
    JMP DisplayAnimationEnemyEnd
DisplayAnimationEnemy
    LDA VISENEMY01-1,X
    STA PlayerBuffer1
    lda EnemyStatus
    CMP #1
    BNE DisplayAnimationEnemyEnd  
    LDA VISENEMYATTACK01-1,X  
    STA PlayerBuffer1 
    jmp DisplayAnimationEnemyEnd       
FinishPlayer1Dead
    LDA #0      
    sta COLUP1
    LDA AnimationCounterIndex
    CMP #1
    BCC DisplayAnimationEnemyEndE  
    ; dead enemy
    LDA VISENEMYDEAD00-1,X  
    STA PlayerBuffer1
    jmp DisplayAnimationEnemyEnd
DisplayAnimationEnemyEndE
    LDA VISENEMYDEAD01-1,X  
    STA PlayerBuffer1
DisplayAnimationEnemyEnd
    ; STA PlayerBuffer1   
    DEC XPosPlayer1   ;and decrement the line count
    jmp FinishPlayer1Skip
FinishPlayer1
FinishPlayer1Skip

    ; -------------------------------------------------
    ; PLAYERMOVEMENTS
    ; -------------------------------------------------
    LDA PlayerBuffer0 ;buffer was set during last scanline
    STA GRP0         ;put it as graphics now
    LDA PlayerBuffer1 ;buffer was set during last scanline
    STA GRP1         ;put it as graphics now

    DEY
    ; version 1.0 > too big distance for a jump!!! (error: < blbal bytes to long)
    ; BNE ScanLoop  
    ; version 2.0
    CPY #1
    BCC ENDOFSCANLOOP
    JMP ScanLoop
ENDOFSCANLOOP



    LDA #2      
    STA WSYNC   
    STA VBLANK  
    LDX #30     
OverScanWait
    STA WSYNC
    DEX
    BNE OverScanWait
    JMP  MainLoop      

; -------------------------------------------------
; /MAINLOOP
; -------------------------------------------------

; -------------------------------------------------
; SUBROUTINES
; -------------------------------------------------

     ; -------------------------------------------------
    ; SOUND / AUDIO
    ; -------------------------------------------------
DoAudio
    ; http://www.randomterrain.com/atari-2600-memories-batari-basic-music-toy.html
    ; effekcts x frequence = ton 
    ; actual sound to play
    ; AUDC1: Controller
    ; AUDF1: Frequence
    ; SOUNDS ARE FROM 
    ; http://atariage.com/forums/topic/118792-atari-2600-sound-effects-library/
    ; debug
    ; jmp DoneSound
    
    ; CHANNEL 0

    lda PlaySound
    cmp #0
    beq NoSound

    ; jmp DoneSound
    ; effects
    lda #16
    sta AUDV0

    INC SoundClk
    CMP #16 
    BNE DONOTDISABLESOUND
    ldx #0
    stx PlaySound
DONOTDISABLESOUND
    
IonPulseCannon
    ; Sound 1: Ion Pulse Cannon.
    ; Volume fades as pitch goes from high to low.  
    LDA #$0F    
    STA AUDC0   
    LDA SoundClk    
    CMP #32 
    BEQ DoneSound   
    STA AUDF0  
    EOR #%11111111  
    AND #%00011111  
    LSR 
    STA AUDV0  
    ; INC SoundClk    
    JMP DoneSound

NoSound
    lda #0
    sta AUDV0
DoneSound

    ; CHANNEL 1
    ; melod
    ; SOUND MAKER ...
    INC AudioChannel0Counter
    lda AudioChannel0Counter
    ; faster direction?
    ldx EnemyDirection
    cpx #10 
    bcs AudioChannelRestartFaster
    cmp #8
    bne AudioChannelNoRestart
    beq AudioChannelRestart
AudioChannelRestartFaster
    cmp #6
    bcc AudioChannelNoRestart
AudioChannelRestart    
    lda #0
    sta AudioChannel0Counter
    inc AudioChannel0Index
    lda AudioChannel0Index
    cmp #12 ; NOTES
    bne AudioChannelNoRestart
    lda #0
    sta AudioChannel0Index
AudioChannelNoRestart 
    ; volume
    LDA #4 ; 0-16 
    STA AUDV1
    lda #0 ; 1-12
    STA AUDC1     
    ; melody
    lda AudioChannel0Index
    ; NOTE 1
    cmp #1
    bne MELODYNOTE0
    lda #1 ; 1-12
    STA AUDC1   
    LDA #28 ; 1-30 
    STA AUDF1
    JMP AudioChannel0Done  
MELODYNOTE0
    ; NOTE 2
    cmp #2
    bne MELODYNOTE1
    lda #1 ; 1-12
    STA AUDC1   
    LDA #27 ; 1-30 
    STA AUDF1
    JMP AudioChannel0Done  
MELODYNOTE1
    cmp #4
    bne MELODYNOTE2
    lda #1 ; 1-12
    STA AUDC1   
    LDA #27 ; 1-30 
    STA AUDF1
    JMP AudioChannel0Done 
MELODYNOTE2
    cmp #6
    bne MELODYNOTE3
    lda #1 ; 1-12
    STA AUDC1   
    LDA #23 ; 1-30 
    STA AUDF1
    JMP AudioChannel0Done 
MELODYNOTE3

AudioChannel0Done 
    rts

DoIntro

    ; set ...
    ldx #0

    lda #1
    ; sta REFP0
    ; sta REFP1
    lda #%11111111
    ; STa HMP0 
    ; STa HMP1 

    lda #%01110001
    ; sta NUSIZ0
    ; lda #%01110001
    ; sta NUSIZ1

    lda #0
    sta COLUP1

DoIntroInternal

    ; lda #1 
    STA WSYNC 


    ; inx
    ; lda #1
    ; sta VDELP0
    ; lda #1
    ; sta REFP1

 
    ;stx COLUP0


    LDA #0
    STA COLUBK
    CPY #10
    BCC NoBackground
    CPY #82
    BCS NoBackground
    LDA BackgroundColor   ;start with a black background
    STA COLUBK
NoBackground

    ; Stx COLUBK
    LDA #0
    STA GRP0 
    CPY #12
    bcc SOMELABEL
    cpy #80
    bcs SOMELABEL
    LDA BATTLEAX0-1,Y
    STA GRP0         ;put it as graphics now
SOMELABEL
    cpx #0
    bcc SOMELABELNOCREAT
    ; adc #2,GameStatus
    lda PRESSSTART-1,Y
    STA GRP1         ;put it as graphics now
SOMELABELNOCREAT


    ; ... attention
    CPY #72
    BNE IntroNoFireButton2
    lda #%10000000              ; A = $80
    bit INPT4
    bne IntroNoFireButton2
    jsr InitGameBackoffice
    LDA BackgroundColor   ;start with a black background
    STA COLUBK
    jsr StartGame
    RTS
IntroNoFireButton2

    DEY
    CPY #1
    BCC DoIntroEnd
    JMP DoIntroInternal
DoIntroEnd    
    rts

StartGame
    ; test
    LDA BackgroundColor ;must be a hit! load in the YPos...
    STA COLUBK  ;and store as the bgcolor    lda #3 ; death now ... 
    
    lda #1 ; in game ; jump into the game  now
    sta GameStatus
    lda #0 ; in game ; jump into the game  now
    sta GameStatusSub
    lda #0
    sta EnemyStatus
    sta PlayerWon
    sta PlayerWonCounter
    lda #4
    sta PlayerStatus 
    lda #1
    sta PlayerAmount
    lda #3
    sta EnemyAmount
    lda #0
    sta EnemyWave

    lda #0
    sta LastCounter

    jsr InitGameBackoffice

    ; jsr InitGameBackoffice
    jsr NextWave
    
    rts

InitGameBackoffice
; Background    
    LDA BackgroundColor   ;start with a black background
    STA COLUBK  
; Color Player 1  & Player 2  
    ; Player 0
    LDA #$1C   
;    LDA #$1E   
    STA COLUP0
    LDA #80
    STA YPosPlayer0 ;Initial Y Position
    ; STA NUSIZ0
    ; Player 1
    LDA #$1C   
    STA COLUP1
    LDA #80
    STA YPosPlayer1 ;Initial Y Position
    LDA #%00000001
    
;Missiles
    ; Missile 1
    LDA #2
    STA ENAM0  
    ; LDA #$20 
    ; LDA #%11111111
    ; STA NUSIZ0  ;make it quadwidth (not so thin, that)
    LDA #$FF    ; -1 in the left nibble
    STA HMM0    ; of HMM1 sets it to moving
    ; STA ENAM0   

    ; Missile 2
    LDA #2
    LDA #%0011010101
    STA ENAM1  ;enable it
    ; LDA #%0000001    
    ; STA NUSIZ1  ;make it quadwidth (not so thin, that)
    LDA #$F0    ; -1 in the left nibble
    STA HMM1    ; of HMM1 sets it to moving

    rts

; levels
NextWave

    inc EnemyWave
    lda #0
    sta EnemyCounter
    sta EnemyCounterIndex
    sta PlayerWon

    LDA BackgroundColor   ;start with a black background
    STA COLUBK

    ; rotate index
    ; lda #100
    ; STA COLUBK
    lda #0
    sta EnemyBehaviourCounter
    lda #0
    sta EnemyBehaviourRotateIndex
    lda #0
    sta EnemyStatus
    lda #0
    sta EnemyDirection
    lda #1
    sta EnemyAmount
    lda #%00110000
    sta EnemyAttackBehavior
    lda #%00000000
    sta EnemyMoveBehavior

    ; JMP ENEMYWAVEEND
    ; wave 
    lda EnemyWave
    cmp #1
    bne ENEMYWAVE0
    lda #%00110000
    ; lda #%11111111
    sta EnemyAttackBehavior    
    lda #1
    sta EnemyDirection
    JMP ENEMYWAVEEND
ENEMYWAVE0
    ; wave 3
    lda EnemyWave
    cmp #2
    bne ENEMYWAVE3
    lda #1
    sta EnemyAmount
    lda #%01111000
    sta EnemyAttackBehavior
    lda #2
    sta EnemyDirection
    lda #%00000000
    sta EnemyMoveBehavior
ENEMYWAVE3
    ; wave 4
    lda EnemyWave
    cmp #3
    bne ENEMYWAVE4
    lda #1
    sta EnemyAmount
    lda #%1100000
    sta EnemyAttackBehavior
    lda #1
    sta EnemyDirection
    lda #%00000010
    sta EnemyMoveBehavior
ENEMYWAVE4
    ; wave 5
    lda EnemyWave
    cmp #4
    bne ENEMYWAVE5
    lda #2
    sta EnemyAmount
    lda #%0011000
    sta EnemyAttackBehavior
    lda #2
    sta EnemyDirection
    lda #%00100000
    sta EnemyMoveBehavior
ENEMYWAVE5
   ; wave 6
    lda EnemyWave
    cmp #5
    bne ENEMYWAVE6
    lda #1
    sta EnemyAmount
    lda #%0001110
    sta EnemyAttackBehavior
    lda #22
    sta EnemyDirection
    lda #%00000000
    sta EnemyMoveBehavior
ENEMYWAVE6
; wave 7
    lda EnemyWave
    cmp #6
    bne ENEMYWAVE7
    lda #3
    sta EnemyAmount
    lda #%0001110
    sta EnemyAttackBehavior
    lda #2
    sta EnemyDirection
    lda #%01000010
    sta EnemyMoveBehavior
ENEMYWAVE7


ENEMYWAVEEND

    ; Player Won
    lda EnemyWave
    cmp #7
    bne ENEMYWAVEENDSTATUE    ; the only friend the end
    lda #3 
    sta PlayerStatus
    lda #1
    sta PlayerWon
    lda #15
    sta PlayerWonCounter
ENEMYWAVEENDSTATUE
    ; go on
    
    rts

DoIngameSize
     ; PLAYER
    LDA #%00000000 ; 00PP DOUBLE
    STA NUSIZ0  ;make it quadwidth (not so thin, that)
    lda PlayerAmount
    cmp #2
    bne PLAYERAMOUNTNOT2
    LDA #%00100001 ; 00PP DOUBLE
    STA NUSIZ0
    JMP PLAYERAMOUNTNOT3
PLAYERAMOUNTNOT2    
    cmp #3
    bne PLAYERAMOUNTNOT3
    LDA #%00000011 ; 00PP DOUBLE
    STA NUSIZ0
PLAYERAMOUNTNOT3    
    ; ENEMY
    LDA #%00100000 ; PPPP DOUBLE
    STA NUSIZ1 ;make it quadwidth (not so thin, that)
    lda EnemyAmount
    cmp #2
    bne ENEMYAMOUNTNOT2
    LDA #%00100001 ; PPPP DOUBLE
    STA NUSIZ1 ;make it quadwidth (not so thin, that)
ENEMYAMOUNTNOT2
    lda EnemyAmount
    cmp #3
    bne ENEMYAMOUNTNOT3
    LDA #%00100011 ; PPPP DOUBLE
    STA NUSIZ1 ;make it quadwidth (not so thin, that)
ENEMYAMOUNTNOT3
    rts

DoIngamePlayerRenderer
    ; Player 0
    LDA #0      
    STA PlayerBuffer0   
    LDX XPosPlayer0   
    BEQ FinishPlayer0
    lda PlayerStatus
    cmp #3 ; // player 3 > death 
    beq FinishPlayer0Dead
    cmp #4 ; // player 3 > death 
    beq FinishPlayer0Shield
    LDA #$1C
    sta COLUP0
IsPlayerOn0 
    ; Look into animation
    LDA AnimationCounterIndex
    cmp #1
    bne DisplayAnimationPlayer
    LDA VISPLAYER00-1,X
    STA PlayerBuffer0  
    lda PlayerStatus
    CMP #1
    BNE DisplayAnimationPlayerEnd  
    LDA VISPLAYERHACK00-1,X  
    STA PlayerBuffer0  
    JMP DisplayAnimationPlayerEnd
DisplayAnimationPlayer
    LDA VISPLAYER01-1,X
    STA PlayerBuffer0  
    lda PlayerStatus
    CMP #1
    BNE DisplayAnimationPlayerEnd  
    LDA VISPLAYERHACK01-1,X 
    STA PlayerBuffer0  
    JMP DisplayAnimationPlayerEnd  
FinishPlayer0Shield 
    lda #0
    sta COLUP0 
    LDA VISSHIELD00-1,X 
    STA PlayerBuffer0  
    LDA AnimationCounterIndex
    cmp #1
    bne FinishPlayer0Shield1
    LDA VISSHIELD01-1,X 
    STA PlayerBuffer0
    JMP  DisplayAnimationPlayerEnd     
FinishPlayer0Shield1
    LDA VISSHIELD00-1,X 
    STA PlayerBuffer0  
    JMP DisplayAnimationPlayerEnd 
FinishPlayer0Dead
    LDA #0
    sta COLUP0
    jsr PlayerDeadShow
    ; STA PlayerBuffer0      
FinishPlayer0Dead1
    JMP DisplayAnimationPlayerEnd 
DisplayAnimationPlayerEnd
    ; STA PlayerBuffer0    
    DEC XPosPlayer0 
    JMP FinishPlayer0  
FinishPlayer0  
    rts

DoGotoMenu
    
    jsr InitGameBackoffice

    lda #0
    sta GameStatus

    rts

    ; -----------------------------
    ; PLAYER MOVEMENTS
    ; -----------------------------
DoIngamePlayerMovement

    ; move it 
    lda PlayerStatus
    cmp #3
    bne PLAYERINPUTNOTPARSEDO
    ldx #0
    STX HMP0 

    jmp PLAYERINPUTNOTPARSED
PLAYERINPUTNOTPARSEDO   

    ; not yet dead
    lda PlayerStatus
    cmp #3
    bne NOTYETDEAD
    lda PlayerFireCountDown
    cmp #1
    bcc FireButtonDone
NOTYETDEAD

    ; action button
    lda #%10000000              ; A = $80
    bit INPT4
    bne NoFireButton

    LDY YPosPlayer0
    ; CPY #100
    ; BCC NoFireButton
    ; INC YPosPlayer0
    ; hack
;    lda #1
;    sta PlayerStatus
    ; count down ...

    lda PlayerStatus
    cmp #3
    bne SKIP
    lda PlayerWonCounter
    cmp #200
    bcc FireButtonDone
SKIP
    lda NewFireButton
    cmp #0
    bne FireButtonDone
    lda #30
    sta PlayerFireCountDown
    lda #1
    sta NewFireButton
    lda #1
    sta PlayerStatus
    jmp FireButtonDone
NoFireButton
    ; reset if fire is zero
    lda #0
    sta NewFireButton
    lda PlayerStatus
    cmp #1
    bne FireButtonDone
    lda #0
    sta PlayerStatus 
    lda #0
    sta PlayerFireCountDown
FireButtonDone

    ; reset play diretion
    lda #0
    ldx #0
    sta PlayerDirection
; horizontal movement
;assum horiz speed will be zero
    LDA #%01000000  ;Left?
    BIT SWCHA 
    BNE SkipMoveLeft
    LDX #$10    ;a 1 in the left nibble means go left
    lda EnemyDirection
    cmp #10
    bcc LESSTHAN10
    LDX #%00100000
LESSTHAN10    
    LDA #%00000000
    STA REFP0    ;unmirror it
    lda #1
    sta PlayerDirection
SkipMoveLeft 
    ; --------------------   
    LDA #%10000000  ;Right?
    BIT SWCHA 
    BNE SkipMoveRight
    ; left
    ;CPX #120
    ;BCC SkipMoveRight
    LDX #$F0    ;a -1 in the left nibble means go right...
    lda EnemyDirection
    cmp #10
    bcc LESSTHAN11
    LDX #%11100000
LESSTHAN11    

    ; LDA #1
    ; RESET
    LDA #%00001000   ;a 1 in D3 of REFP0 says make it mirror
    STA REFP0
    lda #2
    sta PlayerDirection
SkipMoveRight
    STX HMP0    ;set the move for player 0    
STARTUPNOW

PLAYERINPUTNOTPARSED
    rts    

    ; Do Ingame Enemy BEHAVIOUR
DoIngameEnemeyBehaviour
; enemy active?
    lda EnemyStatus
    cmp #3
    beq ENEMYBEHAVIOURDEND
    cmp #4
    beq ENEMYBEHAVIOURDEND
    inc EnemyBehaviourCounter
    lda EnemyBehaviourCounter
    cmp #5
    bne ENEMYBEHAVIOURDEND
    lda #0
    sta EnemyBehaviourCounter
    inc EnemyBehaviourIndex
    lda EnemyBehaviourIndex
    ; sta COLUBK
    cmp #4
    bne ENEMYBEHAVIOURDEND
    
    ; --------------- 
    ; reverse?
    lda #%00000001
    BIT EnemyMoveBehavior
    BEQ NoReverse
    jsr ReverseDirection
NoReverse

    ; ---------------    
    lda #0
    sta EnemyBehaviourIndex
    ; BIT TEST 000x00000 ...
    ; sta COLUBK
    inc EnemyBehaviourRotateIndex
    lda EnemyBehaviourRotateIndex
    cmp #8
    bne ENEMYBEHAVIOURENDLESS
    lda #0
    sta EnemyBehaviourRotateIndex
ENEMYBEHAVIOURENDLESS
    ; default
    lda #115
    ; sta COLUBK
    lda #0
    lda EnemyBehaviourRotateIndex
    ; version 1.0
    CLC ; clear carry
    lda #%00000001
    BIT EnemyAttackBehavior
    beq ENEMYBEHAVIOURCARRYNOTSET 
    CLC
    SEC
ENEMYBEHAVIOURCARRYNOTSET
    ror EnemyAttackBehavior

    ; behavior !!!!
    ; version 1.0
    CLC ; clear carry
    lda #%00000001
    BIT EnemyMoveBehavior
    beq ENEMYMOVEBEHAVIOURCARRYNOTSET 
    CLC
    SEC   
ENEMYMOVEBEHAVIOURCARRYNOTSET
    ror EnemyMoveBehavior     
ENEMYBEHAVIOURDEND  
    
    ; correct settings - status active?
    lda EnemyStatus
    cmp #3
    beq ENEMYBEHAVIOURDENDNOTT
    cmp #4
    beq ENEMYBEHAVIOURDENDNOTT
    lda #1
    sta EnemyStatus
    lda #%00000001
    BIT EnemyAttackBehavior
    bne ENEMYBEHAVIOURDENDNOTT
    lda #0
    sta EnemyStatus
ENEMYBEHAVIOURDENDNOTT 
    rts    

    ; Do Ingame enemies
DoIngameEnemies
   ; -------------------------------------------------
    ; ENEMIES
    ; -------------------------------------------------
    ; demo mode 
    ; lda #%10000000 ; // right extremly fast ; demo mode
    lda #%00010000 ; // left speed 0
    ;lda #%00100000 ; // left speed 1
    ;lda #%00110000 ; // left speed 2
    ;lda #%01000000 ; // left speed 3
    ;lda #%01010000 ; // left speed 4
    ; lda #%11111111 ; // right speed 5
    ; Sta HMP1    ;set the move for player 0

    ; debug
    ; jmp ENEMYMOVE2
    ; stands still
    lda EnemyDirection
    cmp #0
    bne ENEMYMOVE0
ENEMYMOVE0
    ; left
    lda EnemyDirection
    cmp #1 
    bne ENEMYMOVE1
    lda #%00010000 ; // left speed 0
    sta HMP1
    jmp ENEMYMOVE1LEFT
ENEMYMOVE1
    ; left
    lda EnemyDirection
    cmp #11 
    bne ENEMYMOVE11
    lda #%00100000 ; // left speed 0
    sta HMP1
ENEMYMOVE1LEFT
    lda #0
    sta REFP1
ENEMYMOVE11
    ; right
    lda EnemyDirection
    cmp #2
    bne ENEMYMOVE2
    lda #%11111111 ; // left speed 0
    sta HMP1
    LDA #%00001000   ;a 1 in D3 of REFP0 says make it mirror
    STA REFP1
ENEMYMOVE2      
    ; right
    lda EnemyDirection
    cmp #22
    bne ENEMYMOVE22
    lda #%11101110 ; // left speed 0
    sta HMP1
    LDA #%00001000   ;a 1 in D3 of REFP0 says make it mirror
    STA REFP1
ENEMYMOVE22      

    ; -------------------------------------------------
    ; NEXT WAVE
    ; -------------------------------------------------
    ; count down 
    lda GameStatusSub
    cmp #1
    bne GiveMeNextMonsterNot
    inc EnemyCounter    
    lda EnemyCounter
    cmp #50
    bne GiveMeNextMonsterNot
    lda #0
    sta EnemyCounter
    inc EnemyCounterIndex     
    lda EnemyCounterIndex
    cmp #3
    bne GiveMeNextMonsterNot
    jsr NextWave
    lda #0
    sta GameStatusSub
    sta EnemyCounter
    sta EnemyCounterIndex
    jmp GiveMeNextMonsterNotDone
GiveMeNextMonsterNot
;    sty COLUBK
GiveMeNextMonsterNotDone
    rts    

PlayerDeadShow
    LDA PLAYERDEAD0-1,X 
    STA PlayerBuffer0  
    lda PlayerWon
    cmp #1
    bne WAVEX
    LDA VISPLAYERWON-1,X 
    STA PlayerBuffer0  
WAVEX
    rts

EnemyDeath
    ; audio
    lda #1
    jsr PlayThisSound
    ; dec
    dec EnemyAmount
    lda #0
    sta PlayerStatus
    ; check EnemyAmount
    ; 0 > next wave!!!
    lda EnemyAmount
    cmp #0
    BNE NOTTHEENDE
    lda #1
    sta GameStatusSub
    lda #3
    sta EnemyStatus 
    jmp NOTTHEEND
NOTTHEENDE
    jsr ReverseDirection       
NOTTHEEND
    rts

ReverseDirection
    ; jmp EndDirection
    ; other direction now
    lda EnemyDirection
    cmp #1
    bne EndDirection1
    lda #2
    sta EnemyDirection
    jmp EndDirection
EndDirection1
    lda EnemyDirection
    cmp #11
    bne EndDirection11
    lda #22
    sta EnemyDirection
    jmp EndDirection
EndDirection11
    lda EnemyDirection
    cmp #2
    bne EndDirection2
    lda #1
    sta EnemyDirection
    jmp EndDirection
EndDirection2
    lda EnemyDirection
    cmp #22
    bne EndDirection22
    lda #11
    sta EnemyDirection
    jmp EndDirection
EndDirection22

EndDirection
    RTS    

PlayerDeath
    LDA #%00000000
    STA REFP0    ;unmirror it

    LDA BackgroundColorHit ;must be a hit! load in the YPos...
    STA COLUBK  ;and store as the bgcolor    lda #3 ; death now ... 
    DEC PlayerAmount
    lda PlayerAmount
    cmp #0
    beq LastDeath
    ;  lda #3 ; shield !!! > start icon!!!
    ; sta PlayerStatus
    ; lda #2
    ; jsr PlayThisSound
    ; lda #0
    ; sta LastCounter

    jmp EndGame
LastDeath
    lda #3 ; shield !!! > start icon!!!
    sta PlayerStatus
    lda #2
    jsr PlayThisSound
    lda #15
    sta PlayerWonCounter
EndGame
    rts

    ; in a ...
PlayThisSound
    sta PlaySound
    lda #0
    sta SoundClk
    rts

; -------------------------------------------------
; DATA
; -------------------------------------------------

; PLayer


PRESSSTART

VISSHIELDXX
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00111100
    .byte #%00100000
    .byte #%00111100
    .byte #%00100000
    .byte #%00111100
    .byte #%00000000
    .byte #%00100100
    .byte #%00101000
    .byte #%00111000
    .byte #%00100100
    .byte #%00111100
    .byte #%00000000
    .byte #%00010000
    .byte #%00010000
    .byte #%00010000
    .byte #%00010000
    .byte #%00010000
    .byte #%00000000
    .byte #%00100000
    .byte #%00100000
    .byte #%00111000
    .byte #%00100000
    .byte #%00111100
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00111100
    .byte #%00000100
    .byte #%00111100
    .byte #%00100000
    .byte #%00110000
    .byte #%00000000
    .byte #%00111100
    .byte #%00000100
    .byte #%00111100
    .byte #%00100000
    .byte #%00110000
    .byte #%00000000
    .byte #%00111100
    .byte #%00100000
    .byte #%00111100
    .byte #%00100000
    .byte #%00111100
    .byte #%00000000
    .byte #%00100100
    .byte #%00101000
    .byte #%00111000
    .byte #%00100100
    .byte #%00111100
    .byte #%00000000
    .byte #%00100000
    .byte #%00100000
    .byte #%00111000
    .byte #%00100100
    .byte #%00111100
  



; BATTLEAX
BATTLEAX0
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000

LOGO
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000    

SPACE0
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000


SPACE1
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000

    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000
    .byte #%00100000

BATTLEAX1
    .byte #%00100000
    .byte #%00100010
    .byte #%00100110
    .byte #%00101110
    .byte #%00101110
    .byte #%00101110
    .byte #%10101110
    .byte #%00000000

    .byte #%00000000
    .byte #%00000000
    .byte #%00000000
    .byte #%00000000

VISENEMYLOGO0
    .byte #%00000000
    .byte #%11111111
    .byte #%11111111
    .byte #%01100000
    .byte #%01111100
    .byte #%11100001
    .byte #%11111111
    .byte #%00000000

VISENEMYLOGO1
    .byte #%00000000
    .byte #%11100111
    .byte #%11100111
    .byte #%00111110
    .byte #%00011100
    .byte #%11110111
    .byte #%11100011
    .byte #%00000000

VISENEMYLOGO2
    .byte #%00000000
    .byte #%11100011
    .byte #%11100011
    .byte #%01111111
    .byte #%01100011
    .byte #%11100011
    .byte #%11111110
    .byte #%00000000



VISPLAYER00
    .byte #%00100010
    .byte #%00100010
    .byte #%00111110
    .byte #%00100011
    .byte #%11111110
    .byte #%00010100
    .byte #%00111110
    .byte #%00100010
VISPLAYER01
    .byte #%00010100
    .byte #%00010100
    .byte #%00111110
    .byte #%11100010
    .byte #%00111111
    .byte #%00010100
    .byte #%00111110
    .byte #%00100010

VISPLAYERHACK00
    .byte #%00001010
    .byte #%00001010
    .byte #%00011111
    .byte #%00011111
    .byte #%00001110
    .byte #%00101010
    .byte #%01101111
    .byte #%01110001
VISPLAYERHACK01
    .byte #%00010001
    .byte #%00010001
    .byte #%00011111
    .byte #%11011111
    .byte #%11111110
    .byte #%10001010
    .byte #%00011111
    .byte #%00010001

VISPLAYERWON
    .byte #%11111111
    .byte #%00010001
    .byte #%00011111
    .byte #%00011111
    .byte #%00001110
    .byte #%00101010
    .byte #%01101111
    .byte #%01110001


; DEAD 
PLAYERDEAD0 ; WAVE 0! (FIRST NOT COUNTED)
    .byte #%00010000     
    .byte #%00010000     
    .byte #%00010000     
    .byte #%00010000     
    .byte #%01111100     
    .byte #%00010000     
    .byte #%00010000     
    .byte #%00000000     

    .byte #%10001100    
    .byte #%10001000    
    .byte #%11100001    
    .byte #%00100100    
    .byte #%00100000    
    .byte #%01111000    
    .byte #%00001000    
    .byte #%11001000    
    .byte #%11001000    
    .byte #%00011000    
    .byte #%00010010    
    .byte #%00000000    

VISSHIELD00
    .byte #%01000100
    .byte #%01000100
    .byte #%01010100
    .byte #%01000000
    .byte #%01010101
    .byte #%01010100
    .byte #%01010100
    .byte #%00010100  
VISSHIELD01
    .byte #%00010000
    .byte #%00010000
    .byte #%00010100
    .byte #%01000100
    .byte #%00010100
    .byte #%00010100
    .byte #%00010100
    .byte #%00010100 



; Enemy
VISENEMY00
    .byte #%01100100
    .byte #%01100100
    .byte #%01111110
    .byte #%01100010
    .byte #%01111111
    .byte #%01010100
    .byte #%01011100
    .byte #%00011100  
VISENEMY01
    .byte #%10010010
    .byte #%10010010
    .byte #%10111110
    .byte #%11100110
    .byte #%10111110
    .byte #%10010100
    .byte #%10011100
    .byte #%00011100      
VISENEMYATTACK00
    .byte #%00001010
    .byte #%00001010
    .byte #%00001010
    .byte #%01111111
    .byte #%00011111
    .byte #%00001010
    .byte #%00001010
    .byte #%00001110 

VISENEMYATTACK01
    .byte #%00010001
    .byte #%00010001
    .byte #%00011111
    .byte #%11111011
    .byte #%00011111
    .byte #%00001010
    .byte #%00001010
    .byte #%00001110   
VISENEMYDEAD00
    .byte #%01000100
    .byte #%01000100
    .byte #%01010100
    .byte #%01010101
    .byte #%01010101
    .byte #%01010100
    .byte #%01010100
    .byte #%00010100  
VISENEMYDEAD01
    .byte #%00010000
    .byte #%00010000
    .byte #%00010100
    .byte #%01010100
    .byte #%00010100
    .byte #%00010100
    .byte #%00010100
    .byte #%00010100  


        

    org $FFFC
    .word Start
    .word Start